Bug 85258 - Early-out for subtracting a non-intersecting region
: Early-out for subtracting a non-intersecting region
Status: RESOLVED FIXED
: WebKit
New Bugs
: 528+ (Nightly build)
: Unspecified Unspecified
: P2 Normal
Assigned To:
:
:
:
:
  Show dependency treegraph
 
Reported: 2012-04-30 21:15 PST by
Modified: 2012-05-02 12:27 PST (History)


Attachments
Patch (1.41 KB, patch)
2012-04-30 21:20 PST, Dana Jansens
no flags Review Patch | Details | Formatted Diff | Diff


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2012-04-30 21:15:40 PST
Early-out for subtracting a non-intersecting region
------- Comment #1 From 2012-04-30 21:20:02 PST -------
Created an attachment (id=139578) [details]
Patch
------- Comment #2 From 2012-05-01 02:05:59 PST -------
(From update of attachment 139578 [details])
Harvest all low hanging fruits!!
------- Comment #3 From 2012-05-01 02:14:28 PST -------
(From update of attachment 139578 [details])
Clearing flags on attachment: 139578

Committed r115716: <http://trac.webkit.org/changeset/115716>
------- Comment #4 From 2012-05-01 02:14:33 PST -------
All reviewed patches have been landed.  Closing bug.
------- Comment #5 From 2012-05-01 13:14:18 PST -------
Is this change for better performance or is it related to correctness? If it’s for better performance, what test demonstrates the improvement? How good is the improvement?
------- Comment #6 From 2012-05-01 13:32:20 PST -------
It is for performance, if you subtract a Region that does not intersect, you would make a memcpy of the orignal region. Region copies are showing themselves to be very costly, you can see some backstory here https://bugs.webkit.org/show_bug.cgi?id=81076

I must confess I'm not sure what you mean by a test though, we use unit tests and layout tests to verify correctness, but I've never been asked to write a test to show performance differences.
------- Comment #7 From 2012-05-01 13:37:02 PST -------
Most performance-driven changes include information about some kind of performance test and data about the results before and after the code change. I can find you examples if you haven’t seen that in the WebKit project before.
------- Comment #8 From 2012-05-01 13:43:53 PST -------
Sure, I'd love a good example, thanks.
------- Comment #9 From 2012-05-02 12:27:05 PST -------
I’m not sure these are the best examples, but three I found with a quick search are these:

http://trac.webkit.org/changeset/114912
http://trac.webkit.org/changeset/114351
http://trac.webkit.org/changeset/112387